(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-nepali-unicode', ['exports', '@angular/core', '@angular/forms'], factory) :
    (global = global || self, factory(global['ngx-nepali-unicode'] = {}, global.ng.core));
}(this, function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Following Mapping rules are taken from
     * https://raw.githubusercontent.com/Shuvayatra/preeti/master/preeti.js
     */
    /**
     * Unicode Key Mapping
     * @type {?}
     */
    var unicodeMapping = {
        "÷": "/", "v": "ख", "r": "च", "\"": "ू", "~": "ञ्", "z": "श", "ç": "ॐ", "f": "ा", "b": "द", "n": "ल", "j": "व", "×": "×", "V": "ख्", "R": "च्", "ß": "द्म", "^": "६", "Û": "!", "Z": "श्", "F": "ँ", "B": "द्य", "N": "ल्", "Ë": "ङ्ग", "J": "व्", "6": "ट", "2": "द्द", "¿": "रू", ">": "श्र", ":": "स्", "§": "ट्ट", "&": "७", "£": "घ्", "•": "ड्ड", ".": "।", "«": "्र", "*": "८", "„": "ध्र", "w": "ध", "s": "क", "g": "न", "æ": "“", "c": "अ", "o": "य", "k": "प", "W": "ध्", "Ö": "=", "S": "क्", "Ò": "¨", "_": ")", "[": "ृ", "Ú": "’", "G": "न्", "ˆ": "फ्", "C": "ऋ", "O": "इ", "Î": "ङ्ख", "K": "प्", "7": "ठ", "¶": "ठ्ठ", "3": "घ", "9": "ढ", "?": "रु", ";": "स", "'": "ु", "#": "३", "¢": "द्घ", "/": "र", "+": "ं", "ª": "ङ", "t": "त", "p": "उ", "|": "्र", "x": "ह", "å": "द्व", "d": "म", "`": "ञ", "l": "ि", "h": "ज", "T": "त्", "P": "ए", "Ý": "ट्ठ", "\\": "्", "Ù": ";", "X": "ह्", "Å": "हृ", "D": "म्", "@": "२", "Í": "ङ्क", "L": "ी", "H": "ज्", "4": "द्ध", "±": "+", "0": "ण्", "<": "?", "8": "ड", "¥": "र्‍", "$": "४", "¡": "ज्ञ्", ",": ",", "©": "र", "(": "९", "‘": "ॅ", "u": "ग", "q": "त्र", "}": "ै", "y": "थ", "e": "भ", "a": "ब", "i": "ष्", "‰": "झ्", "U": "ग्", "Q": "त्त", "]": "े", "˜": "ऽ", "Y": "थ्", "Ø": "्य", "E": "भ्", "A": "ब्", "M": "ः", "Ì": "न्न", "I": "क्ष्", "5": "छ", "´": "झ", "1": "ज्ञ", "°": "ङ्ढ", "=": ".", "Æ": "”", "‹": "ङ्घ", "%": "५", "¤": "झ्", "!": "१", "-": "(", "›": "द्र", ")": "०", "…": "‘", "Ü": "%"
    };
    /**
     * Replacement Array
     * @type {?}
     */
    var replacementRules = [
        ["्ा", ""], ["(त्र|त्त)([^उभप]+?)m", "$1m$2"], ["त्रm", "क्र"], ["त्तm", "क्त"], ["([^उभप]+?)m", "m$1"], ["उm", "ऊ"], ["भm", "झ"], ["पm", "फ"], ["इ{", "ई"], ["ि((.्)*[^्])", "$1ि"], ["(.[ािीुूृेैोौंःँ]*?){", "{$1"], ["((.्)*){", "{$1"], ["{", "र्"], ["([ाीुूृेैोौंःँ]+?)(्(.्)*[^्])", "$2$1"], ["्([ाीुूृेैोौंःँ]+?)((.्)*[^्])", "्$2$1"], ["([ंँ])([ािीुूृेैोौः]*)", "$2$1"], ["ँँ", "ँ"], ["ंं", "ं"], ["ेे", "े"], ["ैै", "ै"], ["ुु", "ु"], ["ूू", "ू"], ["^ः", ":"], ["टृ", "ट्ट"], ["ेा", "ाे"], ["ैा", "ाै"], ["अाे", "ओ"], ["अाै", "औ"], ["अा", "आ"], ["एे", "ऐ"], ["ाे", "ो"], ["ाै", "ौ"]
    ];

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Nepali Unicode Service
     *
     */
    var NgxNepaliUnicodeService = /** @class */ (function () {
        /**
         * Default Constructor
         */
        function NgxNepaliUnicodeService() {
        }
        /**
         * Function that converts passed input text string into nepali unicode text
         * @param inputText Input Text
         */
        /**
         * Function that converts passed input text string into nepali unicode text
         * @param {?} inputText Input Text
         * @return {?}
         */
        NgxNepaliUnicodeService.prototype.convertToUnicode = /**
         * Function that converts passed input text string into nepali unicode text
         * @param {?} inputText Input Text
         * @return {?}
         */
        function (inputText) {
            //Converted text to be returned
            /** @type {?} */
            var outputText;
            //Map each input text character
            outputText = inputText.toString().split('').map((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                return unicodeMapping[key] || key;
            })).join('');
            //Replace converted values
            replacementRules.forEach((/**
             * @param {?} rule
             * @return {?}
             */
            function (rule) {
                outputText = outputText.replace(new RegExp(rule[0], 'g'), rule[1]);
            }));
            return outputText;
        };
        NgxNepaliUnicodeService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxNepaliUnicodeService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxNepaliUnicodeService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxNepaliUnicodeService_Factory() { return new NgxNepaliUnicodeService(); }, token: NgxNepaliUnicodeService, providedIn: "root" });
        return NgxNepaliUnicodeService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular Directive for Nepali unicode
     *
     */
    var NepaliUnicodeDirective = /** @class */ (function () {
        /**
         * Default Constructor
         * @param nepaliUnicodeService
         */
        function NepaliUnicodeDirective(elementRef, nepaliUnicodeService) {
            this.elementRef = elementRef;
            this.nepaliUnicodeService = nepaliUnicodeService;
        }
        /**
         * Handle element input element
         */
        /**
         * Handle element input element
         * @return {?}
         */
        NepaliUnicodeDirective.prototype.oninput = /**
         * Handle element input element
         * @return {?}
         */
        function () {
            //Input text on element
            /** @type {?} */
            var inputText = this.elementRef.nativeElement.value;
            if (!inputText)
                return;
            //Convert into Nepali unicode
            /** @type {?} */
            var convertedValue = this.nepaliUnicodeService.convertToUnicode(inputText);
            //Set Converted value
            this.elementRef.nativeElement.value = convertedValue;
            /**
             * Set value to passed formcontrol instance
             */
            if (this.formControl) {
                this.formControl.setValue(convertedValue);
            }
        };
        NepaliUnicodeDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[nepaliUnicode]'
                    },] }
        ];
        /** @nocollapse */
        NepaliUnicodeDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: NgxNepaliUnicodeService }
        ]; };
        NepaliUnicodeDirective.propDecorators = {
            formControl: [{ type: core.Input }],
            oninput: [{ type: core.HostListener, args: ['input',] }]
        };
        return NepaliUnicodeDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular pipe for Nepali uniocde
     *
     */
    var NepaliUnicodePipe = /** @class */ (function () {
        /**
         * Default Constructor
         * @param nepaliUnicodeService
         */
        function NepaliUnicodePipe(nepaliUnicodeService) {
            this.nepaliUnicodeService = nepaliUnicodeService;
        }
        /**
         * Transform input text into nepali unicode
         * @param inputText
         */
        /**
         * Transform input text into nepali unicode
         * @param {?} inputText
         * @return {?}
         */
        NepaliUnicodePipe.prototype.transform = /**
         * Transform input text into nepali unicode
         * @param {?} inputText
         * @return {?}
         */
        function (inputText) {
            return inputText ? this.nepaliUnicodeService.convertToUnicode(inputText) : '';
        };
        NepaliUnicodePipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'nepaliUnicode'
                    },] }
        ];
        /** @nocollapse */
        NepaliUnicodePipe.ctorParameters = function () { return [
            { type: NgxNepaliUnicodeService }
        ]; };
        return NepaliUnicodePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxNepaliUnicodeModule = /** @class */ (function () {
        function NgxNepaliUnicodeModule() {
        }
        /**
         * @return {?}
         */
        NgxNepaliUnicodeModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: NgxNepaliUnicodeModule,
                providers: []
            };
        };
        NgxNepaliUnicodeModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NepaliUnicodeDirective, NepaliUnicodePipe],
                        imports: [],
                        exports: [NepaliUnicodeDirective, NepaliUnicodePipe]
                    },] }
        ];
        return NgxNepaliUnicodeModule;
    }());

    exports.NepaliUnicodeDirective = NepaliUnicodeDirective;
    exports.NepaliUnicodePipe = NepaliUnicodePipe;
    exports.NgxNepaliUnicodeModule = NgxNepaliUnicodeModule;
    exports.NgxNepaliUnicodeService = NgxNepaliUnicodeService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-nepali-unicode.umd.js.map
